#include<iostream>
#include<cstdio>
using namespace std;
int main()
{
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	long long ans=0,a=1;
	int n,m;
	cin>>n>>m;
	int i,j,k;
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n-i+1;j++)
			{
				ans+=a*2%1000000007;
				ans%=1000000007;
				a%=1000000007;
			}
	}
	cout<<a<<endl;
	fclose(stdin);
	fclose(stdout);
	return 0;
}